内燃机仿真在内燃机性能预测以及优化方面发挥着越来越重要的作用，内燃机仿真模型包括平均值模型、零维模型、一维模型和三维模型等等。使用零维或者平均值模型过于简化且精度较低，而采用三维模型来计算整机的性能计算成本过高，现阶段较为实用的整机性能预测模型仍然一维非定常流动模型。虽然一维性能仿真模型在管道内部的计算效果较好，但是在各种内燃机管道边界处如多分支管存在明显的多维流动的特征，因此在多分支管处不能采用一维的Euler方程模型，现有商业软件如GT-power中采用的模型为基于准稳态假设的压力损失模型。压力损失模型依赖于实验来测量端口与端口之间的压力损失系数，将测得的大量的实验数据制成表格，插值得出不同三分支管的形状特征参数和流动特征参数来获得压力损失系数，压力损失模型不考虑气流的非定常流动特性以及三通管的接口处细致的形状对流动的影响。为了克服上述三通管计算模型的缺点，本文设计了一种CNN提取管道形状特征结合LSTM预测气流非定常流动演化特性的神经网络来预测三通管道端口之间的压力损失系数。设计的神经网络符合内燃机强瞬变脉冲流动的的特点，预测结果表明，相较于一维非定常的准稳态查表法，设计的神经网络压力计算误差降低5.23%，而相较于采用三维非定常CFD，计算速度能够加速3个数量级。


Internal combustion engine simulation plays an increasingly important role in engine performance prediction and optimization. Common engine simulation models include mean value engine model, 0-D filling and emptying engine model, one-dimensional unsteady flow engine model and three-dimensional engine model, etc. The use of mean value engine model or 0-D filling and emptying engine model is too simplified and less accurate, while the use of three-dimensional models to calculate the performance of the whole engine is too costly, and the more practical model for predicting the performance of the whole engine with limited computating source is still the one-dimensional unsteady flow model. Although the one-dimensional performance simulation model is more effective in the calculation of the interior of the pipe, there are obvious characteristics of multidimensional flow at the pipe boundary of various internal combustion engine pipe such as multi-branch junction, so the one-dimensional Euler equation model cannot be used at the multi-branch junction, and the model used in existing commercial software such as GT-power is the pressure loss model based on the quasi-steady-state assumption. The pressure loss model relies on experiments to measure the port-to-port pressure loss coefficients by interpolating a large amount of experimental data to obtain the pressure loss coefficients by interpolating the shape characteristics and flow characteristics of different three-branch pipes, which do not take into account the non-constant flow characteristics of the airflow and the influence of the detailed shape of the tee interface on the flow. In order to overcome the shortcomings of the above-mentioned T-junction calculation model, this paper designs a new neural network framwork with CNN to extract pipe shape features combined with LSTM to predict the non-constant flow evolution characteristics of airflow to predict the pressure loss coefficient between junction ports. The designed neural network meets the characteristics of strong transient impulse flow in internal combustion engines. The prediction results show that the designed neural network reduces the pressure calculation error by 5.23% compared with the one-dimensional non-constant quasi-steady-state look-up table method, and the calculation speed can be accelerated by 3 orders of magnitude compared with the use of three-dimensional non-constant CFD.



内燃机的准维燃烧模型由于其计算速度较快且能够预测排放的优点在内燃机整机设计、性能预测和优化以及内燃机控制中被广泛应用，然而准维模型同时也存在标定系数较多导致的标定困难的问题。本文提出一种基于Bayesian推理和神经网络代理模型的准维燃烧模型标定方法，其基本思想为给定一个模型参数的先验分布，根据实验结果不断更新标定参数的后验分布，使得燃烧标定参数的不确定性最小化。采用MCC模型作为该方法的验证，结果表明，提出的标定方法能够较快地收敛到较优解，将本方法与种群优化算法进行对比，其收敛速度为传统的种群优化算法的10倍，研究结果对于准维模型的标定有重要意义。



